﻿using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Media;

namespace TestProject
{
    /// <summary>
    /// 메인 페이지
    /// </summary>
    public sealed partial class MainPage : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// 텍스트 블럭 실제 높이
        /// </summary>
        private double textBlockActualHeight;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainPage()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainPage()
        {
            InitializeComponent();

            Loaded += Page_Loaded;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 페이지 로드시 처리하기 - Page_Loaded(sender, e)

        /// <summary>
        /// 페이지 로드시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void Page_Loaded(object sender, RoutedEventArgs e)
        {
            this.textBlockActualHeight = this.textBlock.ActualHeight;

            CompositionTarget.Rendering += CompositionTarget_Rendering;
        }

        #endregion
        #region 구성 타겟 렌더링시 처리하기 - CompositionTarget_Rendering(sender, e)

        /// <summary>
        /// 구성 타겟 렌더링시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void CompositionTarget_Rendering(object sender, object e)
        {
            this.textBlock.FontSize = ActualHeight / textBlockActualHeight;

            RenderingEventArgs renderingEventArgs = e as RenderingEventArgs;

            double t = (0.25 * renderingEventArgs.RenderingTime.TotalSeconds) % 1;

            for(int index = 0; index < this.textBlockForegroundBrush.GradientStops.Count; index++)
            {
                this.textBlockForegroundBrush.GradientStops[index].Offset = index / 7.0 - t;  
            }
        }

        #endregion
    }
}